package de.usu.bs.examples.addressbook;

import javax.jms.Queue;

import org.apache.activemq.command.ActiveMQQueue;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class AddressbookClient {

	public static void main(String[] args) {
		// init spring context
		ApplicationContext ctx = new ClassPathXmlApplicationContext("app-context.xml");

		// get bean from context
		AddressbookJMSSender jmsMessageSender = (AddressbookJMSSender) ctx.getBean("addressbookJMSSender");

		// send to default destination
		jmsMessageSender.send(messageText);

		// send to a code specified destination
		Queue queue = new ActiveMQQueue("AnotherDest");
		jmsMessageSender.send(queue, "hello Another Message");

		// close spring application context
		((ClassPathXmlApplicationContext) ctx).close();
	}

	static String messageText = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:typ=\"http://bs.usu.de/services/examples/addressbook/types\">"
			+ "<soapenv:Header/>" + "<soapenv:Body>" + "<typ:findAddress>" + "<typ:id>990</typ:id>"
			+ "<typ:fistname>John</typ:fistname>" + "<typ:lastname>Doe</typ:lastname>"
			+ "<!--Zero or more repetitions:-->" + "<typ:address>" + "<typ:id>999</typ:id>"
			+ "<typ:type>home</typ:type>" + "<typ:street>Shepards Lane 1</typ:street>"
			+ "<typ:postcode>12-mn-456</typ:postcode>" + "<typ:city>Brixton</typ:city>"
			+ "<typ:country>UK</typ:country>" + "</typ:address>" + "</typ:findAddress>" + "</soapenv:Body>"
			+ "</soapenv:Envelope>";
}
