package de.usu.bs.services.examples.addressbook;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;

import de.usu.bs.examples.ejb.AddressBookRemote;
import de.usu.bs.services.examples.addressbook.types.AddressType;
import de.usu.bs.services.examples.addressbook.types.PersonType;

@WebService( serviceName = "AddressbookJMSServiceEndpoint", 
	targetNamespace = "http://bs.usu.de/services/examples/addressbook", 
	portName = "AddressbookJMSPort", 
	wsdlLocation = "addressbook-jms.wsdl")
@XmlSeeAlso({ de.usu.bs.services.examples.addressbook.types.ObjectFactory.class, ObjectFactory.class })
public class AddressbookServiceJMSProvider implements AddressbookJMSService {

	// Approches to bind/inject an EJB
	// 1.  
	//@Inject
	// 2.
	//@Resource(name="java:module/AddressbookEJB")
	// 3.
	//@Resource(name="ejb:addressbook-ejb.jar/java:app/addressbook-ejb/AddressbookEJB!de.usu.bs.examples.ejb.AddressbookEJB")
	// 4.
	//@Resource(name="java:jboss/exported/addressbook-ejb/AddressbookEJB!de.usu.bs.examples.ejb.AddressBookRemote")
	// 5.
	@Resource(name="ejb:addressbook-ejb/AddressbookEJB!de.usu.bs.examples.ejb.AddressBookRemote")
	AddressBookRemote addressbookEJB;
	
	@Override
	public List<PersonType> findAddress(int id, String fistname, String lastname, List<AddressType> address) {
		System.out.println("Received Message with id="+id);
		System.out.println("EJB 'AddressbookEJB' = " + addressbookEJB);
		if(addressbookEJB!=null){
			System.out.println("Invoke EJB: " + addressbookEJB.getAddressInfo(id));
		}
		List<PersonType> persons = new ArrayList<PersonType>();
		PersonType person = new PersonType();
		person.setId(1001);
		person.setFistname("John");
		person.setLastname("Doe");
		AddressType address1 = new AddressType();
		address1.setId(2001);
		address1.setStreet("Main Raod 10");
		address1.setCity("London");
		address1.setPostcode("52-SX-88A");
		address1.setCountry("UK");
		person.getAddress().add(address1);
		persons.add(person);
		return persons;
	}

}
